Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.Designer.cs	(revision 5420)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.Designer.cs	(revision 5421)
@@ -73,6 +73,6 @@
       // valueGroupBox
       // 
-      this.valueGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.valueGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.valueGroupBox.Controls.Add(this.configureButton);
@@ -96,8 +96,8 @@
       this.configureButton.Name = "configureButton";
       this.configureButton.Size = new System.Drawing.Size(24, 24);
-      this.configureButton.TabIndex = 3;
+      this.configureButton.TabIndex = 1;
       this.configureButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Edit;
       this.configureButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
-      this.toolTip.SetToolTip(this.configureButton, "Edit ValidValues");
+      this.toolTip.SetToolTip(this.configureButton, "Edit Values");
       this.configureButton.UseVisualStyleBackColor = true;
       this.configureButton.CheckedChanged += new System.EventHandler(this.configureButton_CheckedChanged);
@@ -113,5 +113,5 @@
       this.showInRunCheckBox.Name = "showInRunCheckBox";
       this.showInRunCheckBox.Size = new System.Drawing.Size(90, 17);
-      this.showInRunCheckBox.TabIndex = 1;
+      this.showInRunCheckBox.TabIndex = 2;
       this.showInRunCheckBox.Text = "&Show in Run:";
       this.toolTip.SetToolTip(this.showInRunCheckBox, "Check to show the value of this parameter in each run.");
@@ -121,6 +121,6 @@
       // viewHost
       // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.viewHost.Caption = "View";
@@ -131,5 +131,5 @@
       this.viewHost.ReadOnly = false;
       this.viewHost.Size = new System.Drawing.Size(374, 185);
-      this.viewHost.TabIndex = 2;
+      this.viewHost.TabIndex = 3;
       this.viewHost.ViewsLabelVisible = true;
       this.viewHost.ViewType = null;
@@ -137,5 +137,5 @@
       // valueComboBox
       // 
-      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.valueComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.cs	(revision 5420)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterConfigurationView.cs	(revision 5421)
@@ -23,19 +23,11 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
 
 namespace HeuristicLab.Parameters.Views {
-  /// <summary>
-  /// The visual representation of a <see cref="Parameter"/>.
-  /// </summary>
-  [View("ConstrainedValueParameter ConfigurationView")]
+  [View("ConstrainedValueParameter Configuration View")]
   [Content(typeof(OptionalConstrainedValueParameter<>), false)]
   [Content(typeof(ConstrainedValueParameter<>), false)]
   public partial class ConstrainedValueParameterConfigurationView<T> : ConstrainedValueParameterView<T> where T : class, IItem {
-
-    /// <summary>
-    /// Initializes a new instance of <see cref="VariableView"/> with caption "Variable".
-    /// </summary>
     public ConstrainedValueParameterConfigurationView() {
       InitializeComponent();
@@ -48,4 +40,5 @@
 
     protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
       configureButton.Enabled = Content != null && !ReadOnly;
     }