Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs	(revision 5385)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/BoundsChecker.cs	(revision 5423)
@@ -30,6 +30,6 @@
 namespace HeuristicLab.Encodings.RealVectorEncoding {
   /// <summary>
-  /// Checks if all elements of a real vector are inside the bounds. 
-  /// If not, the elements are corrected.
+  /// Checks if all elements of a real vector are inside the bounds.
+  /// If not, elements are set to the respective values of the bounds.
   /// </summary>
   [Item("BoundsChecker", "Checks if all elements of a real vector are inside the bounds. If not, elements are set to the respective values of the bounds.")]
@@ -61,5 +61,5 @@
 
     /// <summary>
-    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not they are corrected.
+    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not, elements are set to the respective values of the bounds.
     /// </summary>
     /// <param name="bounds">The lower and upper bound (1st and 2nd column) of the positions in the vector. If there are less rows than dimensions, the rows are cycled.</param>
@@ -75,5 +75,5 @@
 
     /// <summary>
-    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not they are corrected.
+    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not, elements are set to the respective values of the bounds.
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown when either vector or bounds could not be found.</exception>
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ReflectiveBoundsChecker.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ReflectiveBoundsChecker.cs	(revision 5385)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ReflectiveBoundsChecker.cs	(revision 5423)
@@ -30,6 +30,6 @@
 namespace HeuristicLab.Encodings.RealVectorEncoding {
   /// <summary>
-  /// Checks if all elements of a real vector are inside the bounds. 
-  /// If not, the elements are corrected.
+  /// Checks if all elements of a real vector are inside the bounds.
+  /// If not, the elements are mirrored at the bounds.
   /// </summary>
   [Item("ReflectiveBoundsChecker", "Checks if all elements of a real vector are inside the bounds. If not, elements are mirrored at the bounds.")]
@@ -47,5 +47,5 @@
     protected ReflectiveBoundsChecker(ReflectiveBoundsChecker original, Cloner cloner) : base(original, cloner) { }
     /// <summary>
-    /// Initializes a new instance of <see cref="BoundsChecker"/> with two parameters
+    /// Initializes a new instance of <see cref="ReflectiveBoundsChecker"/> with two parameters
     /// (<c>RealVector</c>, <c>Bounds</c>).
     /// </summary>
@@ -61,5 +61,5 @@
 
     /// <summary>
-    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not they are corrected.
+    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not, they are mirrored at the bounds.
     /// </summary>
     /// <param name="bounds">The lower and upper bound (1st and 2nd column) of the positions in the vector. If there are less rows than dimensions, the rows are cycled.</param>
@@ -89,5 +89,5 @@
 
     /// <summary>
-    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not they are corrected.
+    /// Checks if all elements of the given <paramref name="vector"/> are inside the bounds and if not, they are mirrored at the bounds.
     /// </summary>
     /// <exception cref="InvalidOperationException">Thrown when either vector or bounds could not be found.</exception>