Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 5439)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 5440)
@@ -92,4 +92,5 @@
 		{00814351-4AB8-4088-9B99-F62787B89E93} = {00814351-4AB8-4088-9B99-F62787B89E93}
 		{3EAF1454-086D-44A2-8509-B1BA24DB1865} = {3EAF1454-086D-44A2-8509-B1BA24DB1865}
+		{2C429157-9C34-4DD3-9D5F-B444B751E39A} = {2C429157-9C34-4DD3-9D5F-B444B751E39A}
 		{3BD61258-31DA-4B09-89C0-4F71FEF5F05A} = {3BD61258-31DA-4B09-89C0-4F71FEF5F05A}
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6}
Index: /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/IDiscreteDoubleMatrixModifier.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/IDiscreteDoubleMatrixModifier.cs	(revision 5439)
+++ /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/IDiscreteDoubleMatrixModifier.cs	(revision 5440)
@@ -28,5 +28,5 @@
   public interface IDiscreteDoubleMatrixModifier : IItem {
     ILookupParameter<DoubleMatrix> ValueParameter { get; }
-    IValueLookupParameter<DoubleValue> ScaleParameter { get; }
+    ILookupParameter<DoubleValue> ScaleParameter { get; }
     ConstrainedValueParameter<IDiscreteDoubleValueModifier> ScalingOperatorParameter { get; }
     IValueLookupParameter<DoubleValue> StartValueParameter { get; }
Index: /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VelocityBoundsModifier.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VelocityBoundsModifier.cs	(revision 5439)
+++ /trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VelocityBoundsModifier.cs	(revision 5440)
@@ -37,6 +37,6 @@
       get { return (ILookupParameter<DoubleMatrix>)Parameters["Matrix"]; }
     }
-    public IValueLookupParameter<DoubleValue> ScaleParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["Scale"]; }
+    public ILookupParameter<DoubleValue> ScaleParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Scale"]; }
     }
     public ConstrainedValueParameter<IDiscreteDoubleValueModifier> ScalingOperatorParameter {
@@ -64,11 +64,8 @@
     [StorableConstructor]
     private VelocityBoundsModifier(bool deserializing) : base(deserializing) { }
-    private VelocityBoundsModifier(VelocityBoundsModifier original, Cloner cloner)
-      : base(original, cloner) {
-      ParameterizeModifiers();
-    }
+    private VelocityBoundsModifier(VelocityBoundsModifier original, Cloner cloner) : base(original, cloner) { }
     public VelocityBoundsModifier() {
       Parameters.Add(new LookupParameter<DoubleMatrix>("Matrix", "The double matrix to modify."));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("Scale", "Scale parameter."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Scale", "Scale parameter."));
       Parameters.Add(new ConstrainedValueParameter<IDiscreteDoubleValueModifier>("ScalingOperator", "Modifies the value"));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("StartValue", "The start value of 'Value'.", new DoubleValue(1)));
@@ -79,5 +76,4 @@
 
       Initialize();
-      ParameterizeModifiers();
     }
 
@@ -87,17 +83,7 @@
     #endregion
 
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      ParameterizeModifiers();
-    }
-
     private void Initialize() {
       foreach (IDiscreteDoubleValueModifier op in ApplicationManager.Manager.GetInstances<IDiscreteDoubleValueModifier>()) {
         ScalingOperatorParameter.ValidValues.Add(op);
-      }
-    }
-
-    private void ParameterizeModifiers() {
-      foreach (IDiscreteDoubleValueModifier op in ScalingOperatorParameter.ValidValues) {
         op.ValueParameter.ActualName = ScaleParameter.Name;
         op.StartValueParameter.ActualName = StartValueParameter.Name;